=== debian/changelog ===
cryptominisat (5.11.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.6.1.
  * Drop the spelling errors and manpage patches.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 03 Oct 2022 10:25:26 +0200
