## cryptominisat 5.11.4%2Bdfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -199,10 +199,24 @@
 
 macro(add_sanitize_flags)
 if (SANITIZE)
-    #MESSAGE(WARNING "Using clang sanitizers -- you MUST use clang++ or the compile WILL fail")
-    add_sanitize_option("-fsanitize-trap=undefined,float-divide-by-zero,unsigned-integer-overflow,implicit-conversion,local-bounds,bounds,return,alignment,null,integer,enum,bool,float-cast-overflow,integer-divide-by-zero,signed-integer-overflow")
-    add_sanitize_option("-fsanitize=address")
-    add_sanitize_option("-fno-sanitize-recover")
+    MESSAGE(WARNING " --Using clang sanitizers -- you MUST use clang++ or the compile WILL fail")
+    SET( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS}  -lasan -lubsan " )
+    SET( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lasan -lubsan ")
+    add_compile_options("-fsanitize=address")
+    #    add_compile_options("-fsanitize=integer")
+    add_compile_options("-fsanitize=undefined")
+    add_compile_options("-fsanitize=null")
+    add_compile_options("-fsanitize=alignment")
+    #add_compile_options("-fno-sanitize-recover")
+    add_compile_options("-fsanitize=return")
+    add_compile_options("-fsanitize=bounds")
+    add_compile_options("-fsanitize=float-divide-by-zero")
+    add_compile_options("-fsanitize=integer-divide-by-zero")
+    #    add_compile_options("-fsanitize=unsigned-integer-overflow")
+    add_compile_options("-fsanitize=signed-integer-overflow")
+    add_compile_options("-fsanitize=bool")
+    add_compile_options("-fsanitize=enum")
+    add_compile_options("-fsanitize=float-cast-overflow")
     add_compile_options("$<$<CONFIG:RELWITHDEBINFO>:-D_GLIBCXX_ASSERTIONS>")
 endif()
 endmacro()
@@ -304,21 +318,3 @@
 
 
     # set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /INCREMENTAL:NO")
-    # set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /PDBCOMPRESS")
-    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:1572864")
-
-    #what does this do?
-    set(DEF_INSTALL_CMAKE_DIR CMake)
-endif()
-
-option(ENABLE_TESTING "Enable testing" OFF)
-option(COVERAGE "Build with coverage check" OFF)
-
-if (COVERAGE AND BUILD_SHARED_LIBS)
-    MESSAGE(FATAL_ERROR "Coverage can only be computed on static compilation")
-endif()
-
-if (NOT WIN32)
-    if(NOT ENABLE_TESTING AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT COVERAGE)
-        add_cxx_flag_if_supported("-fvisibility=hidden")
-    endif()
