=== debian/changelog ===
cryptominisat (5.11.4+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Include cmake files in -dev package (needed for cvc5)

 -- Scott Talbert <swt@techie.net>  Thu, 03 Nov 2022 14:49:01 -0400

cryptominisat (5.11.4+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 28 Oct 2022 19:50:03 +0200
