## cryptominisat 5.11.15+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -148,7 +148,6 @@
     set(ONLY_SIMPLE ON)
     set(BUILD_SHARED_LIBS ON)
     set(NOZLIB ON)
-    set(NOM4RI ON)
 else()
     set(THREADS_PREFER_PTHREAD_FLAG ON)
     find_package (Threads REQUIRED)
@@ -203,6 +202,7 @@
     SET( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS}  -lasan -lubsan " )
     SET( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lasan -lubsan ")
     add_compile_options("-fsanitize=address")
+    # below warns on overflows EVEN when that's OK, because it's well-defined, disabling
     #    add_compile_options("-fsanitize=integer")
     add_compile_options("-fsanitize=undefined")
     add_compile_options("-fsanitize=null")
@@ -317,4 +317,3 @@
     add_compile_options(/EHsc)
 
 
-    # set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /INCREMENTAL:NO")
