=== src/CMakeLists.txt ===
--- 
+++ 
@@ -203,13 +203,6 @@
     SET(cryptoms_lib_link_libs ${cryptoms_lib_link_libs} ${MPI_CXX_LIBRARIES})
 endif()
 
-if (M4RI_FOUND)
-    include_directories(${M4RI_INCLUDE_DIRS})
-
-    SET(cryptoms_lib_files ${cryptoms_lib_files} toplevelgauss.cpp)
-    SET(cryptoms_lib_link_libs ${cryptoms_lib_link_libs} ${M4RI_LIBRARIES})
-endif (M4RI_FOUND)
-
 if (BOSPHORUS_LIBRARIES)
     include_directories( ${BOSPHORUS_INCLUDE_DIRS} )
 
@@ -231,6 +224,12 @@
     )
     SET(cryptoms_lib_link_libs ${cryptoms_lib_link_libs} ${SQLITE3_LIBRARIES})
 endif ()
+
+if (ARJUN_SERIALIZE)
+    SET(cryptoms_lib_link_libs
+        ${cryptoms_lib_link_libs}
+        Boost::serialization)
+endif()
 
 if (FINAL_PREDICTOR)
     SET(cryptoms_lib_files ${cryptoms_lib_files}
@@ -300,37 +299,15 @@
 endif()
 
 if (IPASIR)
-#     if ((NOT WIN32) AND (STATICCOMPILE))
-#         add_library(ipasircryptominisat5_tmp
-#             ipasir.cpp
-#             ${cryptoms_lib_files}
-#             cryptominisat.cpp
-#         )
-#         add_custom_target(ipasircryptominisat5_target
-#               COMMAND ${CMAKE_AR} rc libipasircryptominisat5.a
-#               $<TARGET_FILE:ipasircryptominisat5_tmp>
-#               ${cryptoms_lib_link_libs}
-#         )
-#         add_dependencies(ipasircryptominisat5_target cryptominisat5 ipasircryptominisat5_tmp)
-#         add_custom_target(ipasir_final ALL)
-#         add_custom_command(TARGET ipasir_final
-#             COMMAND ${CMAKE_COMMAND} -E copy
-#                 ${CMAKE_CURRENT_BINARY_DIR}/libipasircryptominisat5.a
-#                 ${PROJECT_BINARY_DIR}/lib/
-#         )
-#         add_dependencies(ipasir_final ipasircryptominisat5_target)
-#     else ()
     add_library(ipasircryptominisat5
         ipasir.cpp
         ${cryptoms_lib_files}
         cryptominisat.cpp
     )
-#         set_target_properties(ipasircryptominisat5 PROPERTIES LINK_SEARCH_START_STATIC 1)
     target_link_libraries(ipasircryptominisat5
         LINK_PUBLIC ${cryptoms_lib_link_libs}
         LINK_PUBLIC ${CMAKE_THREAD_LIBS_INIT}
     )
-#         set_target_properties(ipasircryptominisat5 PROPERTIES LINK_SEARCH_END_STATIC 1)
     set_target_properties(ipasircryptominisat5 PROPERTIES
         OUTPUT_NAME ipasircryptominisat5
         PUBLIC_HEADER "${cryptominisat5_public_headers}"
@@ -345,3 +322,22 @@
         RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
         PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/cryptominisat5"
     )
+endif()
+
+cmsat_add_public_header(cryptominisat5 ${CMAKE_CURRENT_SOURCE_DIR}/cryptominisat_c.h )
+cmsat_add_public_header(cryptominisat5 ${CMAKE_CURRENT_SOURCE_DIR}/cryptominisat.h )
+cmsat_add_public_header(cryptominisat5 ${CMAKE_CURRENT_SOURCE_DIR}/solvertypesmini.h )
+cmsat_add_public_header(cryptominisat5 ${CMAKE_CURRENT_SOURCE_DIR}/dimacsparser.h )
+cmsat_add_public_header(cryptominisat5 ${CMAKE_CURRENT_SOURCE_DIR}/streambuffer.h )
+
+# -----------------------------------------------------------------------------
+# Copy public headers into build directory include directory.
+# The cryptominisat5Config.cmake we generate in the build directory depends on
+# this.
+# -----------------------------------------------------------------------------
+set(HEADER_DEST "${PROJECT_BINARY_DIR}/include/cryptominisat5")
+add_custom_target(CopyPublicHeaders ALL)
+get_target_property(cryptominisat5_public_headers cryptominisat5 PUBLIC_HEADER)
+foreach(public_header ${cryptominisat5_public_headers})
+    get_filename_component(HEADER_NAME ${public_header} NAME)
+    add_custom_command(TARGET CopyPublicHeaders PRE_BUILD
