=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -84,9 +84,7 @@
 # endif()
 
 
-include_directories(
-    ${PROJECT_SOURCE_DIR}
-)
+include_directories( ${PROJECT_SOURCE_DIR} )
 include_directories(
     #${PROJECT_BINARY_DIR}/cmsat5-src
     ${PROJECT_BINARY_DIR}/include
