=== debian/changelog ===
cryptominisat (5.11.15+dfsg1-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:57:30 +0000

cryptominisat (5.11.15+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061910

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Feb 2024 23:03:48 +0000

cryptominisat (5.11.15+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch for gcc 13 (now unneeded).
  * Bump standards-version to 4.6.2.
  * Fix clean target (Closes: #1044932).

 -- Julien Puydt <jpuydt@debian.org>  Thu, 14 Dec 2023 10:26:35 +0100

cryptominisat (5.11.4+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with GCC 13 (Closes: #1037611)
  * Remove broken symlink (Closes: #1040548)

 -- Scott Talbert <swt@techie.net>  Fri, 14 Jul 2023 16:23:16 -0400
