=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: cryptominisat
 Section: math
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Julian Rüth <julian.rueth@fsfe.org>,
            Julien Puydt <jpuydt@debian.org>
-Build-Depends: cmake,
+Build-Depends: dpkg-dev (>= 1.22.5), cmake,
                debhelper-compat (=13),
                dh-python,
                help2man,
@@ -14,12 +15,15 @@
                python3-dev,
                python3-setuptools,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://www.msoos.org/
 Vcs-Git: https://salsa.debian.org/science-team/cryptominisat.git
 Vcs-Browser: https://salsa.debian.org/science-team/cryptominisat
 
-Package: libcryptominisat5-5.11
+Package: libcryptominisat5-5.11t64
+Provides: ${t64:Provides}
+Replaces: libcryptominisat5-5.11
+Breaks: libcryptominisat5-5.11 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -58,7 +62,7 @@
 Multi-Arch: same
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libcryptominisat5-5.11 (= ${binary:Version}), ${misc:Depends}
+Depends: libcryptominisat5-5.11t64 (= ${binary:Version}), ${misc:Depends}
 Description: development files for the CryptoMiniSat SAT solver
  CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
  .
