=== debian/watch ===
version=4
opts="\
repacksuffix=+dfsg1,\
dversionmangle=s/\+dfsg\.\d//,\
" \
https://github.com/msoos/cryptominisat/tags .*/v?(\d\S+)\.tar\.gz
